Unit KeyPress;

Interface

Var
  PLeft,
  PRight,
  PUp,
  PDown,
  PFive,
  PSpace  : Boolean;

Procedure Set_Handler;
Procedure Remove_Handler;

Implementation

Uses DOS;

Const
  Old_Handler : Pointer = Nil;

Procedure New_Handler; Interrupt; Assembler;
Asm
  Push    AX
  In      AL, 60h
  Mov     AH, AL
  And     AH, 80h
  Xor     AH, 80h
  Rol     AH, 1
  And     AL, 7Fh

  Cmp     AL, 39h {space}
  JNE     @Up
  Mov     PSpace, AH
@Up:
  Cmp     AL, 48h {up}
  JNE     @Left
  Mov     PUp, AH
@Left:
  Cmp     AL, 4Bh {left}
  JNE     @Five
  Mov     PLeft, AH
@Five:
  Cmp     AL, 4Ch {five}
  JNE     @Right
  Mov     PFive, AH
@Right:
  Cmp     AL, 4Dh {right}
  JNE     @Down
  Mov     PRight, AH
@Down:
  Cmp     AL, 50h {down}
  JNE     @Other
  Mov     PDown, AH

@Other:
  Pop     AX
  PushF
  Call    DWord Ptr [Old_Handler]
End;

Procedure Set_Handler;
Begin
  If Old_Handler <> Nil then Exit;
  PLeft := False;
  PRight := False;
  PUp := False;
  PDown := False;
  PFive := False;
  PSpace := False;
  GetIntVec (9, Old_Handler);
  SetIntVec (9, @New_Handler)
End;

Procedure Remove_Handler;
Begin
  If Old_Handler = Nil then Exit;
  SetIntVec (9, Old_Handler);
  Old_Handler := Nil
End;

End.
